﻿using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace MVVMDoubleClickEvent
{
    public class CellValuePresenter
    {
        public static readonly DependencyProperty DoubleClickCommandProperty = DependencyProperty.RegisterAttached("DoubleClickCommand", typeof(ICommand), typeof(CellValuePresenter), 
            new PropertyMetadata(null, OnDoubleClickCommandChanged));
        public static void SetDoubleClickCommand(ValuePresenter grid, ICommand command)
        {
            grid.SetValue(DoubleClickCommandProperty, command);
        }
        public static ICommand GetDoubleClickCommand(ValuePresenter grid)
        {
            return grid.GetValue(DoubleClickCommandProperty) as ICommand;
        }

       

        private static void OnDoubleClickCommandChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
        {
            ValuePresenter presenter = (ValuePresenter)d;
            presenter.MouseDoubleClick += (o, ea) =>
            {
                ICommand command = (ICommand)presenter.GetValue(DoubleClickCommandProperty);
                object commandParameter = null; //TODO: add support for parameter

                if (command.CanExecute(commandParameter))
                    command.Execute(commandParameter);
            };

            presenter.MouseDoubleClick += (o, ea) =>
            {
                ICommand command = (ICommand)presenter.GetValue(DoubleClickCommandProperty);
                object commandParameter = presenter.GetValue(DoubleClickCommandParameterProperty);

                if (command.CanExecute(commandParameter))
                    command.Execute(commandParameter);
            };
        }


        public static readonly DependencyProperty DoubleClickCommandParameterProperty = DependencyProperty.RegisterAttached("DoubleClickCommandParameter", typeof(object), typeof(CellValuePresenter));
        public static void SetDoubleClickCommandParameter(ValuePresenter grid, object parameter)
        {
            grid.SetValue(DoubleClickCommandParameterProperty, parameter);
        }
        public static object GetDoubleClickCommandParameter(ValuePresenter grid)
        {
            return grid.GetValue(DoubleClickCommandParameterProperty);
        }


    }
}
