﻿using Microsoft.Practices.Prism.Commands;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;

namespace MVVMDoubleClickEvent
{
    public class MainViewModel : INotifyPropertyChanged
    {
        public ICommand DoubleClickCommand { get; set; }

        public ObservableCollection<Person> People { get; set; }

        public MainViewModel()
        {
            DoubleClickCommand = new DelegateCommand<object>(ExecuteClick);

            People = new ObservableCollection<Person>();

            for (int x = 0; x < 10; x++)
            {
                People.Add(new Person() { FirstName = String.Format("First {0}", x), LastName = String.Format("Last {0}", x) });
            }
        }

       
        public void ExecuteClick(object parameter)
        {
            var person = parameter as Person;

            if (person == null)
                return;

            MessageBox.Show(String.Format("You double clicked on {0} {1}", person.FirstName, person.LastName));
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected void NotifyPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }



}
